<template>
		<mind-form v-model="formPlanilla" :title="`Planilla`"
			@submit="onSubmitPlanilla" hide-buttons
			>
				<template v-slot="{form}">
					<el-divider content-position="left">Datos Planilla</el-divider>
					<el-row>
						<el-col  :lg="12" >
							<el-form-item label="Móvil" required >
								<el-select v-model="form.movil" placeholder="Móvil" :disabled="!!form.id">
									<el-option
										v-for="item in movilesLibres"
										:key="item.movil"
										:label="item.movil"
										:value="item.movil">
									</el-option>
								</el-select>
							</el-form-item>
						</el-col>
						<el-col  :lg="12" >
							<el-form-item label="Chofer" required >
								<el-select v-model="form.idChofer" placeholder="Móvil" :disabled="!!form.id" filterable>
									<el-option
										:disabled="item.disabled"
										v-for="item in choferesLibres"
										:key="item.id"
										:label="`${item.apellido}, ${item.nombre}`"
										:value="item.id">
									</el-option>
								</el-select>
								<!-- <el-input v-model.number="form.idChofer" :disabled="!!form.id" required/> -->
							</el-form-item>
						</el-col>
					</el-row>
					<el-row>
						<el-col  :lg="12" >
						<el-form-item required label="Turno">
							<el-select v-model="form.turno"  :disabled="!!form.id">
								<el-option label="Día"  value="Día"/>
								<el-option label="Intermedio"  value="Intermedio"/>
								<el-option label="Noche"  value="Noche" />
							</el-select>
						</el-form-item>
						</el-col>
						<el-col  :lg="12" >
							<el-form-item  label="Estado">
							<b>{{form.estado}}</b>
							</el-form-item>
						</el-col>

					</el-row>
					<el-row>
						<el-col  :lg="12" >
							<el-form-item label="Fecha Apertura" >
								<el-date-picker :disabled="!!form.id"
									v-model="form.fechaApertura"
									value-format="yyyy-MM-dd"
									type="date"
									>
								</el-date-picker>
							</el-form-item>
						</el-col>
						<el-col  :lg="12" >
							<el-form-item label="Hora" >
								<el-time-select :disabled="!!form.id"
									v-model="form.horaApertura"
									:picker-options="{
										start: '00:00',
										step: '00:30',
										end: '23:45'
									}"
									>
								</el-time-select>
							</el-form-item>
						</el-col>
						<el-col  :lg="12" >
							<el-form-item label="Fecha Cierre" >
								<el-date-picker disabled
									v-model="form.fechaCierre"
									value-format="yyyy-MM-dd"
									type="date"
									>
								</el-date-picker>
							</el-form-item>
						</el-col>
						<el-col  :lg="12" >
							<el-form-item label="Hora" >
								<el-time-select disabled
									v-model="form.horaCierre"
									:picker-options="{
										start: '00:00',
										step: '00:30',
										end: '23:45'
									}"
									>
								</el-time-select>
							</el-form-item>
						</el-col>
					</el-row>
					<el-row>
						<el-form-item label="Notas" >
							<el-input
								type="textarea"
								:rows="2"
								placeholder="Notas"
								v-model="form.obs">
							</el-input>
						</el-form-item>
					</el-row>
					<!-- <el-row class="table-container"> -->
					<template v-if="idPlanilla && idPlanilla != 'new'">
						<el-divider content-position="left">Viajes</el-divider>
						<mind-table :data="listaViajes" row-key="id" >
							<el-table-column prop="origen" label="Origen"  />
							<el-table-column prop="destino" label="Destino"  />
							<el-table-column prop="horaSalida" label="Hora Salida"  />
							<el-table-column prop="horaLlegada" label="Hora Llegada"  />
							<el-table-column prop="importe" label="Viaje"  />
							<el-table-column prop="espera" label="Espera"  />
							<el-table-column prop="estado" label="Estado"  />
							<!-- <el-table-column label="Acción" width="100px" /> -->
						</mind-table>
						<el-divider content-position="left">Totales</el-divider>
						<el-row>
							<el-col  :lg="6"  >
								<el-form-item label="Total $" >
									<b class="total">$ {{totalPlanilla.toFixed(2)}}</b>
								</el-form-item>
							</el-col>
							<el-col  :lg="6"  >
								<el-form-item label="Combustible" >
									<el-input
										type="text" :disabled="!infoComision.combustibleAgencia"
										v-model.number="form.combustible">
										<span slot="prefix">$</span>
										</el-input>
								</el-form-item>
							</el-col>
							<el-col  :lg="6"  >
								<el-form-item label="Gastos" >
									<el-input
										type="text" :disabled="!infoComision.gastosAgencia"
										v-model.number="form.gastos" >
										<span slot="prefix">$</span>
										</el-input>
								</el-form-item>
							</el-col>
							<el-col  :lg="6"  >
								<el-form-item label="Comision" >
									<b class="total">{{comisionPorcentaje}}%</b>
								</el-form-item>
							</el-col>
						</el-row>
						<el-row>
							<el-col  :lg="6"  >
								<el-form-item label="Subtotal" >
									<b class="total">$ {{subtotal.toFixed(2)}}</b>
								</el-form-item>
							</el-col>
							<el-col  :lg="6"  >
								<el-form-item label="C. Agencia" >
									<b class="total">$ {{combustibleAgencia.toFixed(2)}}</b>
								</el-form-item>
							</el-col>
							<el-col  :lg="6"  >
								<el-form-item label="Gastos Agencia" >
									<b class="total">$ {{gastosAgencia.toFixed(2)}}</b>

								</el-form-item>
							</el-col>
							<el-col  :lg="6"   >
								<el-form-item  label="A Pagar">
									<b class="total">$ {{comisionImporte.toFixed(2)}}</b>
								</el-form-item>
							</el-col>
						</el-row>
					</template>
				</template>
				<template  v-slot:footer="{form}" >
					<!-- <el-button type="danger" v-if="esAnulable" @click="anularPlanilla(form)">Anular Planilla</el-button> -->
					<el-button type="info" v-if="!esReadOnly && idPlanilla" :disabled="!!viajesActivos" @click="finalizarPlanilla(form)">Finalizar Planilla</el-button>
					<el-button type="primary" v-if="!idPlanilla" @click="onSubmitPlanilla(form)">Aplicar</el-button>
				</template>
		</mind-form>
	
</template>
<script>
import storePlanillas from '@/store/planillas'
import storeComisiones from '@/store/comisiones'

import {Rest} from '@/../vendor/mind-core-web/'

export default {
	props: {
		idPlanilla: Number,
		dialogo: Boolean,
		/**
		 * controla la visibilidad del diálogo
		 */
		visible: Boolean,
	},
	async created(){
		storePlanillas.idAgencia = 1
		this.apiMoviles = new Rest({
			uri: `/api/viajes/agencias/${storePlanillas.idAgencia}/moviles`, 
			state: this.store_moviles.data,
			key: 'id'})

		await this.apiMoviles.FetchAll().catch((error)=>{
			this.$message({
				showClose: true,
				type: 'error',
				message: error
			});
		})

		this.apiChoferes = new Rest({
			uri: `/api/viajes/agencias/${storePlanillas.idAgencia}/choferes`, 
			state: this.store_choferes.data,
			key: 'id'})

		await this.apiChoferes.FetchAll({
			sort: ['apellido','nombre'],
		}).catch((error)=>{
			this.$message({
				showClose: true,
				type: 'error',
				message: error
			});
		})

		this.apiComisiones = new Rest({
			uri: `/api/viajes/agencias/${storePlanillas.idAgencia}/comisiones`, 
			state: storeComisiones.data,
			key: 'id'
		})
		


	},
	computed: {
		// esAnulable() {
		// 	return this.formPlanilla.id && (this.formPlanilla.estado == 'Abierta' || this.formPlanilla.estado == 'Suspendida')
		// },
		esReadOnly(){
			return this.formPlanilla.estado != 'Abierta'
		},
		// esAnulada() {
		// 	return this.formPlanilla.estado == 'Anulada'
		// },
		dialogoVisible: {
			get() {
				return this.visible
			} ,
			set(v) {
				this.$emit('update:visible', v)
			}
		},
		listaViajes() {
			this.viajes.RESOURCE_LIST.forEach((v) => {
				v.origen = `${v.origenCalle} ${v.origenNumero || ''}`
				v.destino = `${v.destinoCalle} ${v.destinoNumero || ''}`
			})
			return this.viajes.RESOURCE_LIST
		},
		viajesActivos() {

			return this.viajes.RESOURCE_LIST.filter((v)=>{
				return v.estado == 'En Curso'
			}).length
		},
		movilesLibres() {
			return this.store_moviles.data.RESOURCE_LIST.filter((m)=>{
				if(!m.activo) {
					return false
				}
				if(storePlanillas.data.RESOURCE_LIST.find((p)=>{
					return p.movil == m.movil
				})) {
					return false
				}

				return true
			})
		},
		choferesLibres() {
			//filtra los inactivos
			if(!this.store_choferes.data.RESOURCE_LIST) {
				return []
			}

			let res = this.store_choferes.data.RESOURCE_LIST.filter((ch)=>{
				if(!ch.activo) {
					return false
				}
				return true
			})

			//deshabilito los choferes ocupados
			res.forEach((ch)=>{
				if(storePlanillas.data.RESOURCE_LIST.find((p)=>{
					// console.log(p.m)
					return p.idChofer == ch.id
				})) {
					ch.disabled = true
				}
			})

			//retorno la lista ordanada por estado de chofere
			return res.sort((ch1, ch2)=>{
				const ch1Disabled = ch1.disabled ? 1 : 0 
				const ch2Disabled = ch2.disabled ? 1 : 0
				if(ch1Disabled < ch2Disabled) {
					return -1
				}
				if(ch1Disabled > ch2Disabled) {
					return 1
				}
				return 0
			})

		},
		totalPlanilla() {
			if(this.formPlanilla.estado != 'Abierta') {
				return this.formPlanilla.totalPlanilla
			}
			let total = 0
			this.viajes.RESOURCE_LIST.forEach((v) => {
				const espera = isNaN(v.espera) ||  !v.espera ? 0 : parseFloat(v.espera)
				const viaje = isNaN(v.importe) || !v.importe ? 0 : parseFloat(v.importe)
				total += espera + viaje
				// console.log(v)
			})
			return total
		},
		comisionPorcentaje() {
			if(this.formPlanilla.estado != 'Abierta') {
				return this.formPlanilla.comisionPorcentaje
			}	
			return this.infoComision.comision || 20
		},
		/**
		 * devuelve el importe de gastos de combustible a cargo de la agencia
		 */
		combustibleAgencia() {
			if(this.formPlanilla.estado != 'Abierta') {
				return this.formPlanilla.combustibleAgencia
			}	
			return parseFloat(this.formPlanilla.combustible && this.infoComision.combustibleAgencia ? this.formPlanilla.combustible * this.infoComision.combustibleAgencia / 100 : 0)
		},
		/**
		 * devuelve el importe de gastos generales a cargo de la agencia
		 */
		gastosAgencia() {
			if(this.formPlanilla.estado != 'Abierta') {
				return this.formPlanilla.gastosAgencia
			}	
			return parseFloat(this.formPlanilla.gastos && this.infoComision.gastosAgencia ? this.formPlanilla.gastos * this.infoComision.gastosAgencia / 100 : 0)
		},

		/**
		 * devuelve la comisión a pagar, sin descontar los gastos de agencia
		 */
		subtotal() {
			if(this.formPlanilla.estado != 'Abierta') {
				return this.formPlanilla.comisionImporte
			}			
			return (this.totalPlanilla) * this.comisionPorcentaje / 100
		},

		comisionImporte() {
			if(this.formPlanilla.estado != 'Abierta') {
				return this.formPlanilla.comisionImporte
			}			
			return (this.subtotal - this.combustibleAgencia - this.gastosAgencia)
		},

	},
	watch: {
		idPlanilla: {
			immediate: true,
			handler(v) {
				this.api = new Rest({
					uri: `/api/viajes/agencias/${storePlanillas.idAgencia}/planillas`, 
					state: storePlanillas.data,
					key: 'id'})

				this.apiViajes = new Rest({
					uri: `/api/viajes/agencias/${storePlanillas.idAgencia}/viajes`, 
					state: this.viajes,
					key: 'id'})

				if(v) {
						this.editarPlanilla(v)
						} else {
						this.nuevaPlanilla()
					}
			}

		}
	},
	methods: {
		async editarPlanilla(id) {
			this.formPlanilla = await this.api.Fetch(id).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});				
			})
			await this.apiViajes.FetchAll({
				filters:{
					idPlanilla: id
				}
			}).catch((error)=>{
				this.$message({
					showClose: true,
					type: 'error',
					message: error
				});
			})
			const estado = this.formPlanilla.estado
			if(estado == 'Abierta') {
				const movil = this.formPlanilla.movil
				const datosMovil = await this.apiMoviles.Fetch(movil).catch((error)=>{
					this.$message({
						showClose: true,
						type: 'error',
						message: error
					});				
				})
				const idComision = datosMovil.idComision
				if(!idComision) {
					this.$message({
						showClose: true,
						type: 'error',
						message: "El movil no tiene esquema de comisió asignado! Asigne un esquema de comisión."
					})
					return;
				}
	
				this.infoComision = await this.apiComisiones.Fetch(idComision).catch((error)=>{
					this.$message({
						showClose: true,
						type: 'error',
						message: error
					});				
				})
			}

		},

		nuevaPlanilla() {
			let date = new Date()
			const hoy = `${date.getFullYear()}/${(date.getMonth() +1 )}/${date.getDate()}`
			const ahora = `${date.getHours()}:${(date.getMinutes() < 10 ? '0' + date.getMinutes(): date.getMinutes())}`
			this.formPlanilla = {
				estado: 'Abierta',
				estadoMovil: 'Libre',
				fechaApertura: hoy,
				horaApertura: ahora,
			}
		},
		/*
		anularPlanilla(planilla) {
			this.$confirm('Confirma la Anulación del Planilla?', 'Anular Planilla', {
					confirmButtonText: 'Si',
					cancelButtonText: 'No',
					type: 'warning'
				}).then(async () => {
					await this.api.Delete(planilla)
					.then(()=>{
						this.$message({
							showClose: true,
							type: 'warning',
							message: "Se Anuló el Planilla"
						});
					})
					.catch((error)=>{
						this.$message({
							showClose: true,
							type: 'error',
							message: error
						});
					})
				this.$emit('submit')
				})
		},*/
		finalizarPlanilla(planilla) {
			this.$confirm('Confirma la Finalización del Planilla?', 'Finalizar Planilla', {
					confirmButtonText: 'Si',
					cancelButtonText: 'No',
					type: 'warning'
				}).then(async () => {
					planilla.totalPlanilla = this.totalPlanilla
					planilla.comisionPorcentaje = this.comisionPorcentaje
					planilla.comisionImporte = this.comisionImporte
					planilla.gastosAgencia = this.gastosAgencia
					planilla.combustibleAgencia = this.combustibleAgencia
					planilla.estado = 'Cerrada'
					const date = new Date()
					const hoy = `${date.getFullYear()}/${(date.getMonth() +1 )}/${date.getDate()}`
					const ahora = `${date.getHours()}:${(date.getMinutes() < 10 ? '0' + date.getMinutes(): date.getMinutes())}`
					planilla.fechaCierre = hoy
					planilla.horaCierre = ahora
					this.onSubmitPlanilla(planilla)
					// console.log(planilla)
					// this.$emit('submit')
				}).catch(()=>{ })
		},

		async onSubmitPlanilla(planilla) {
			let result, msg ;
			if(planilla.id) { //planilla Existente
				await this.api.Patch(planilla)
				.then(()=>{
					result = 'success'
					msg = 'Planilla actualizada correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			} else { //planilla nuevo
				await this.api.Post(planilla)
				.then(()=>{
					result = 'success'
					msg = 'Planilla creada correctamente'
				})
				.catch((error)=> {
					result = 'error'
					msg = error
				})
			}
			this.$message({
				type: result,
				showClose: result == 'error',
				message: msg
			});
			this.$emit('submit')
		}
	},
	data(){
		return{
			api: null,
			apiMoviles: null,
			apiChoferes: null,
			apiComisiones: null,
			formPlanilla: {},
			viajes: {},
			store_moviles: {
				data:{}
				},
			store_choferes: {
				data:{}
				},
			infoComision: {},
			// dialogoVisible: false,
		}
	}
}
</script>
<style scoped>
.el-card {
	margin-bottom: 10px;
	margin-top: 10px;
	/* background: rgba(224, 213, 52, 0.05); */
	font: 13px Small;
}

.el-card:hover {
	background: rgba(0,0,0,0.05);
	cursor: pointer;
}

.el-divider {
	margin: 10px 0px;
}

label {
	font-weight: bold;
	width: 70px;
	display: inline-block;
}
.table-container {
	min-height: 300px;
}

.total {
	/* float:right; */
	margin-right: 10px;
}
/* .el-button {
	position: ;
	top: 5px;
} */

</style>
